<!DOCTYPE html>
<html lang="en-GB" xmlns="http://www.w3.org/1999/xhtml">
<head>
  <meta charset="UTF-8" />
  <title>Test Page for tabindex</title>
  <meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=yes" />
  <link rel="stylesheet" type="text/css" media="screen" href="../../../css/verdemoderna.css" title="default" />
  <link rel="top" href="../../../index.html" title="Accessibility Works: Home page" />
  <meta name="robots" content="noindex, nofollow" />
  <style>
    form { border: 1px solid #666; margin: 20px auto; padding-left: 20px; }
    label { display: block; }
    *[tabindex]:focus::after { content: 'i=' attr(tabindex); color: #BA0021; background-color: #FFD700; }
    input[tabindex]:focus, button[tabindex]:focus { outline: 2px solid gold; }

    details > summary { transition: color 1s; color: black; outline: 1px solid black; }
    details > summary::marker { font-size: 1.6rem; }
    summary#wai-aria-summary { max-width: 7.8rem; padding: .2rem; }
    details[open] > summary { color: red; }
    h2:focus, summary:focus { outline: 2px solid red; }
    details:focus { outline: 2px dotted lime; }
  </style>
  <script src="../../../js/utilities.js"></script>
  <script src="tabindex.js"></script>
</head>
<body>
  <header id="header">
    <h1><span class="h1txt">Test Page for <code>tabindex</code> (Success Criterion 2.4.3 Focus Order)</span></h1>
  </header>

  <main id="main">
    <h2 tabindex="-1">Form Example</h2>
    <form action="index.html" method="get" class="form-example">
      <p><label for="name">Name (required): </label> <input type="text" id="name" name="name" required="required" autocomplete="name" tabindex="4" /></p>
      <p><label for="email">E-mail: </label> <input type="email" id="email" name="email" autocomplete="email" tabindex="3" /></p>
      <p><button type="submit" tabindex="2">Submit</button>
        <button type="reset" disabled="disabled">Reset</button>
        <!--adding tabindex="2" does not put a disabled button to the tabbing order in Firefox-->
      </p>
    </form>

    <h2>Focusable Elements</h2>
    <ul>
      <li><a href="https://html.spec.whatwg.org/#links">Links</a>:
        <a href="https://html.spec.whatwg.org/#the-a-element"><code>a</code> element</a> with <code>href</code>,
        <a href="https://html.spec.whatwg.org/#the-area-element"><code>area</code> element</a> with <code>href</code>
      </li>
      <li>Form elements:
        <a href="https://html.spec.whatwg.org/#the-input-element"><code>input</code></a> (without a <code>type="hidden"</code> attribute),
        <a href="https://html.spec.whatwg.org/#the-select-element-2"><code>select</code></a>,
        <a href="https://html.spec.whatwg.org/#the-textarea-element"><code>textarea</code></a>,
        <a href="https://html.spec.whatwg.org/#the-button-element"><code>button</code></a>
        (unless they are diabled)
      </li>
      <li><code>button</code> outside forms
      </li>
      <li><a href="https://html.spec.whatwg.org/#the-summary-element"><code>summary</code></a>
      </li>
      <li>Natively non-interactive elements with a non-negative <a href="https://html.spec.whatwg.org/#the-tabindex-attribute"><code>tabindex</code> attibute</a>
      </li>
    </ul>
    <p>The value of the <code>tabindex</code> attribute must be a <a href="https://html.spec.whatwg.org/#valid-integer">valid integer</a>.
      <abbr>HTML</abbr> 4.01's limitation to <a href="https://www.w3.org/TR/html401/interact/forms.html#adef-tabindex">values between 0 and 32767</a> no longer exists.
    </p>

    <h2><code>details</code> and <code>summary</code> Example</h2>
    <details>
      <summary id="wai-aria-summary"><abbr>WAI-ARIA</abbr></summary>
      <p><strong>Web Accessibility Initiative – Accessible Rich Internet Applications (<abbr>WAI-ARIA</abbr>)</strong>
        is a technical specification published by the <a href="https://www.w3.org/">World Wide Web Consortium (<abbr>W3C</abbr>)</a>
        that specifies how to increase the accessibility of web pages, in particular, dynamic content, and user interface components developed with Ajax, <abbr>HTML</abbr>, JavaScript and related technologies.
      </p>
      <p>In the 15 September 2008 working draft, <a href="https://www.w3.org/TR/SVGTiny12/index.html"><abbr>SVG</abbr> 1.2 Tiny</a> added support for WAI-ARIA.
        On 20 March 2014, <a href="https://www.w3.org/TR/wai-aria-1.0/"><abbr>WAI-ARIA</abbr> 1.0</a> became a completed <abbr>W3C</abbr> Recommendation.
        On 14 December 2017, <a href="https://www.w3.org/TR/wai-aria-1.1/"><abbr>WAI-ARIA</abbr> 1.1</a> became a completed <abbr>W3C</abbr> Recommendation.
      </p>
      <p>(Adapted from the article <a href="https://en.wikipedia.org/wiki/WAI-ARIA"><abbr>WAI-ARIA</abbr></a> on Wikipedia.)</p>
    </details>
    <p>See also
      <a href="https://css-tricks.com/exploring-what-the-details-and-summary-elements-can-do/">Exploring What the Details and Summary Elements Can Do</a>
      by Robin Rendle (26 November 2020).
    </p>

    <h2 tabindex="0">Heading with <code>tabindex=0</code></h2>
    <p><code>h2</code> is a type of element that natively does not receive keyboard focus.
      Adding a non-negative <code>tabindex</code> attribute adds this element to the tabbing order.
    </p>

    <h2>Misaligned Keyboard Focus and Keyboard Listener</h2>
    <p><code>a</code> element with keyboard listener but without <code>href</code> attribute, containing a <code>span</code> element with <code>tabindex=0</code> with neither a <code>role</code> or a keyboard listener:
      <a id="test-misaligned-keyboard-access-1"><span tabindex="2" class="history">History</span></a>.
      (Check the console for potential output. When a screen reader is running, key events may not go to the correct element.)
    </p>
  </main>

  <footer id="footer">
    <p id="licence">
    <a class="image" rel="license" href="http://creativecommons.org/licenses/by-sa/4.0/">
    <img alt="Creative Commons License Attribution-ShareAlike" style="border-width:0" src="../../../img/cc-licence-by-sa-88x31.png" />
    </a>
    <br />
    <span>
    <a href="https://cstrobbe.gitlab.io/A11yWorks/" tabindex="32767">Accessibility Works</a></span>
    by <a href="https://gitlab.com/cstrobbe">Christophe Strobbe</a>
    is licensed under a
    <a lang="en-US" rel="license" href="http://creativecommons.org/licenses/by-sa/4.0/">Creative Commons Attribution-ShareAlike 4.0 International License</a>.
    </p>

    <p><a href="../../../sitemap.html">Site map</a>.</p>
    <p>You can <a href="https://gitlab.com/cstrobbe/A11yWorks" tabindex="1">fork the code</a> on GitLab.</p>
  </footer>
</body>
</html>